@use 'vue-multiselect/dist/vue-multiselect.css';
@use '../core/placeholders/input';

.multiselect {
  @extend %input;

  min-height: var(--input-height);
  padding: 0;
  margin: 0;
  background-color: var(--input-background-color-green);
  font-size: var(--input-font-size);

  // Area that displays selection
  &__tags {
    min-height: var(--input-height);
    padding: 0;
    border: none;
    margin: 0;
    background-color: var(--input-background-color-green);
    overflow-x: hidden;
    text-overflow: ellipsis;
  }

  &__spinner {
    background: transparent;

    &::before,
    &::after {
      margin: -17px 0 0 -13px;
    }
  }

  // Tags list
  &__tags-wrap {
    display: block;
    padding-left: var(--spacer-small);
  }

  // Vue-multiselect original tag component
  &__tag {
    padding: var(--spacer-tiny) var(--spacer-large) var(--spacer-tiny) var(--spacer-small);
    margin: var(--spacer-tiny) 0;
    margin-right: var(--spacer-default);
    background: var(--component-content-background);
    color: var(--foreground-color);
    font-size: var(--font-size-small);

    &-icon {
      width: 3ex;
      padding: 0;
      background-color: var(--component-content-background-alt);

      &::after {
        position: absolute;
        top: -3px;
        right: 1ex;
        color: var(--foreground-color);
      }
    }
  }

  // Typing area
  &__input {
    padding: 0;
    margin: 0;
  }

  // Input placeholder
  &__placeholder {
    padding: var(--spacer-tiny) var(--spacer-small);
    color: var(--input-color-placeholder-color);
    font-size: var(--input-font-size);
    opacity: var(--input-placeholder-opacity);
  }

  // Arrow area
  &__select {
    all: unset;
    position: absolute;
    z-index: 1;
    right: 0;
    width: var(--input-height);
    height: var(--input-height);
    padding: 0;
    line-height: 1em;

    &::before {
      top:0;
      display: inline-block;
      width: 1.6rem;
      height: 1.6rem;
      border: none;
      margin:0;
      background-image: var(--form-select-arrow);
      background-position-x: right var(--spacer-small);
      background-position-y: center;
      background-repeat: no-repeat;
      background-size: 1rem 1rem;
      content: '';
    }
  }

  // Selected value in a single-select
  &__single {
    width: 100%;
    max-width: 100%;
    height: var(--input-height);
    padding-top: var(--spacer-tiny);
    padding-right: var(--spacer-large);
    border: none;
    background-color: var(--input-background-color-green);
    color: var(--input-color);
    overflow-x: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  // List wrapper
  &__content-wrapper {
    border: 1px solid var(--border-color);
    background: var(--component-content-background);
    color: var(--foreground-color);
  }

  // List element wrapper
  &__element {
    margin: 0;
  }

  // List element content
  &__option {
    display: flex;
    min-height: var(--menu-item-height);
    align-items: center;
    padding: 0 var(--spacer-default);
    margin: 0;
    font-size: var(--font-size-base);

    // Action helper
    &::after {
      display: flex;
      min-height: var(--menu-item-height);
      align-items: center;
      padding: 0 var(--spacer-default);
      margin: 0;
      background-color: var(--state-color-green);
      color: var(--state-color-green-alt);
      line-height: unset;
    }

    // Option group header
    &--group {
      padding-left: var(--spacer-small);
      border-top: 1px solid var(--border-color);
      border-bottom: 1px solid var(--border-color);
      background: var(--button-background);
      color: var(--foreground-color);
      font-weight: var(--font-weight-bold);

      &::after {
        border-top: 1px solid var(--border-color);
        border-bottom: 1px solid var(--border-color);
      }

      .multiselect__element:first-child &,
      .multiselect__element:first-child &::after {
        border-top: none
      }

      .multiselect__element:last-child &,
      .multiselect__element:last-child &::after {
        border-bottom: none
      }

      // Hover
      &.multiselect__option--highlight,
      &.multiselect__option--highlight::after,
      {
        background-color: var(--state-color-blue);
        color: var(--state-color-blue-alt);
      }
    }

    // Hovered
    &--highlight {
      background-color: var(--button-background--hover);
      color: var(--button-color);
    }

    // Disabled option
    &--disabled {
      background: transparent !important; // stylelint-disable-line declaration-no-important
      color: var(--state-color-mute);
      cursor: not-allowed !important; // stylelint-disable-line declaration-no-important
    }

    &--selected {
      background-color: var(--button-background--active);
      color: var(--foreground-color);

      // Hovered
      &.multiselect__option--highlight {
        background-color: var(--button-background--hover);

        &::after {
          background-color: var(--state-color-red);
          color: var(--state-color-red-alt);
        }
      }
    }
  }

  // Opened
  &--active {
    .multiselect {
      &__select {
        transform: none;
      }

      &__tags {
        border-radius: var(--border-radius) var(--border-radius) 0 0;
      }

      &__input {
        border-radius: 0;
      }

      // Ensure all the borders are the same
      &__content-wrapper {
        border: 1px solid var(--border-color);
      }
    }
  }

  // Closed
  &:not(&--active) {
    .multiselect__tags {
      height: var(--input-height);
    }
  }
}

.rui-modal__content {

  // Augments modal height instead of overflowing
  .multiselect__content-wrapper { position: absolute; }
}
